<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/29/2004 *
 * ===============                              Last change: 08/29/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : lib-mysql3.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Database layer for MySQL +3.x server             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Datenbankschicht fuer MySQL +3.x Server          *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// SQL queries
function SQL_QUERY ($sql_string, $F, $L) {
	global $link, $CSS, $_CONFIG, $OK;

	// Link is up?
	if (!is_resource($link)) return false;

	// Remove \t, \n and \r from queries they may confuse some MySQL version I have heard
	$sql_string = str_replace("\t", " ", str_replace("\n", " ", str_replace("\r", " ", $sql_string)));

	// Starting time
	$querytimeBefore = array_sum(explode(' ', microtime()));

	// Run SQL command
	//* DEBUG: */ echo $sql_string."<br />\n";
	$result = mysql_query($sql_string, $link)
	 or addFatalMessage($F." (".$L."):".mysql_error()."<br />
Query string:<br />
".$sql_string);

	// Ending time
	$querytimeAfter = array_sum(explode(' ', microtime()));

	// Calculate query time
	$queryTime = $querytimeAfter - $querytimeBefore;

	// Save last successfull query
	$_CONFIG['db_last_query'] = $sql_string;

	// Count this query
	incrementConfigEntry('sql_count');

	// Debug output
	//* DEBUG: */ print "Query=<pre>".$sql_string."</pre>, affected=<strong>".SQL_AFFECTEDROWS()."</strong>, numrows=<strong>".SQL_NUMROWS($result)."</strong><br />\n";

	if (($CSS != "1") && ($CSS != "-1") && (isBooleanConstantAndTrue('DEBUG_MODE')) && (isBooleanConstantAndTrue('DEBUG_SQL'))) {
		//
		// Debugging stuff...
		//
		$fp = @fopen(PATH."inc/cache/mysql.log", 'a') or mxchange_die("Cannot write mysql.log!");
		if (!isset($OK)) {
			// Write first entry
			fwrite($fp, "Module=".$GLOBALS['module']."\n");
			$OK = true;
		} // END - if
		fwrite($fp, $F."(LINE=".$L."|NUM=".SQL_NUMROWS($result)."|AFFECTED=".SQL_AFFECTEDROWS()."|QUERYTIME:".$queryTime."): ".str_replace('\r', "", str_replace('\n', " ", $sql_string))."\n");
		fclose($fp);
	} // END - if

	// Count DB hits
	if (getConfig('db_hits_run') == null) {
		// Count in dummy variable
		$_CONFIG['db_hits_run'] = 1;
	} else {
		// Count to config array
		$_CONFIG['db_hits_run']++;
	}

	// Return the result
	return $result;
}

// SQL num rows
function SQL_NUMROWS($result) {
	// Is the result a valid resource?
	if (is_resource($result)) {
		// Get the count of rows from database
		$lines = mysql_num_rows($result);

		// Is the result empty? Then we have an error!
		if (empty($lines)) $lines = 0;
	} else {
		// No resource given, no lines found!
		$lines = 0;
	}
	return $lines;
}

// SQL affected rows
function SQL_AFFECTEDROWS() {
	global $link;

	// Valid link resource?
	if (!is_resource($link)) return false;

	// Get affected rows
	$lines = mysql_affected_rows($link);

	// Return it
	return $lines;
}

// SQL fetch row
function SQL_FETCHROW($result) {
	// Init data
	$DATA = array();

	// Is a result resource set?
	if (!is_resource($result)) return false;

	$DATA = mysql_fetch_row($result);
	return $DATA;
}

// SQL fetch array
function SQL_FETCHARRAY($res, $nr=0, $remove_numerical=true) {
	// Is a result resource set?
	if (!is_resource($res)) return false;

	// Initialize array
	$row = array();

	// Load row from database
	$row = mysql_fetch_array($res);

	// Return only arrays here
	if (is_array($row)) {
		// Shall we remove numerical data here automatically?
		if ($remove_numerical) {
				 // So let's remove all numerical elements to save memory!
			$max = count($row);
			for ($idx = 0; $idx < ($max / 2); $idx++) {
				// Remove entry
				unset($row[$idx]);
			}
		}

		// Return row
		return $row;
	} else {
		// Return a false here...
		return false;
	}
}

// SQL result
function SQL_RESULT($res, $row, $field) {
	$result = mysql_result($res, $row, $field);
	return $result;
}
// SQL connect
function SQL_CONNECT($host, $login, $password, $F, $L) {
	$connect = mysql_connect($host, $login, $password) or addFatalMessage($F." (".$L."):".mysql_error());
	return $connect;
}
// SQL select database
function SQL_SELECT_DB($dbName, $link, $F, $L) {
	$select = false;
	if (is_resource($link)) {
		$select = mysql_select_db($dbName, $link) or addFatalMessage($F." (".$L."):".mysql_error());
	}
	return $select;
}
// SQL close link
function SQL_CLOSE(&$link, $F, $L) {
	global $_CONFIG, $cacheInstance, $cacheArray;

	// Is there still a valid link?
	if (!is_resource($link)) {
		// Skip double close
		return false;
	} // END - if

	// Do we need to update cache/db counter?
	//* DEBUG: */ echo "DB=".getConfig('db_hits').",CACHE=".getConfig('cache_hits')."<br />\n";
	if ((GET_EXT_VERSION("cache") >= "0.0.7") && (getConfig('db_hits') > 0) && (getConfig('cache_hits') > 0) && (is_object($cacheInstance))) {
		// Add new hits
		$_CONFIG['db_hits'] += getConfig('db_hits_run');

		// Update counter for db/cache
		UPDATE_CONFIG(array("db_hits", "cache_hits"), array(bigintval(getConfig('db_hits')), bigintval(getConfig('cache_hits'))));
	} // END - if

	// Close database link and forget the link
	$close = mysql_close($link) or addFatalMessage($F." (".$L."):".mysql_error());
	$link = null;
	return $close;
}

// SQL free result
function SQL_FREERESULT ($result) {
	if (!is_resource($result)) {
		// Abort here
		return false;
	} // END - if

	$res = mysql_free_result($result);
	return $res;
}

// SQL string escaping
function SQL_QUERY_ESC ($qstring, $data, $file, $line, $run=true, $strip=true) {
	global $link;

	// Link is there?
	if (!is_resource($link)) return false;

	// Init variable
	$query = "failed";

	if ($strip) {
		$strip = "true";
	} else {
		$strip = "false";
	}

	$eval = "\$query = sprintf(\"".$qstring."\"";
	foreach ($data as $var) {
		if ((!empty($var)) || ($var === 0)) {
			$eval .= ", SQL_ESCAPE(\"".$var."\",true,".$strip.")";
		} else {
			$eval .= ", ''";
		}
	}
	$eval .= ");";
	//
	// Debugging
	//
	//* DEBUG: */ $fp = fopen(PATH."inc/cache/escape_debug.log", 'a') or mxchange_die("Cannot write debug.log!");
	//* DEBUG: */ fwrite($fp, $file."(".$line."): ".str_replace("\r", "", str_replace("\n", " ", $eval))."\n");
	//* DEBUG: */ fclose($fp);

	// Run the code
	eval($eval);

	// Was the eval() command fine?
	if ($query == "failed") {
		// Something went wrong?
		print "eval=".htmlentities($eval)."<pre>";
		debug_print_backtrace();
		die("</pre>");
	} // END - if

	if ($run) {
		// Run SQL query (default)
		return SQL_QUERY($query, $file, $line);
	} else {
		// Return secured string
		return $query;
	}
}

// Get ID from last INSERT command
function SQL_INSERTID () {
	global $link;
	if (!is_resource($link)) return false;
	return mysql_insert_id();
}

// Escape a string for the database
function SQL_ESCAPE ($str, $secureString=true,$strip=true) {
	global $link;

	// Secure string first? (which is the default behaviour!)
	if ($secureString) {
		// Then do it here
		$str = secureString($str, $strip);
	} // END - if

	if (!is_resource($link)) {
		// Fall-back to addslashes() when there is no link
		return addslashes($str);
	} // END - if

	if (function_exists('mysql_real_escape_string')) {
		// The new and improved version
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):str={$str}<br />\n";
		return mysql_real_escape_string($str, $link);
	} elseif (function_exists('mysql_escape_string')) {
		// The obsolete function
		return mysql_escape_string($str, $link);
	} else {
		// If nothing else works
		return addslashes($str);
	}
}

// SELECT query string from table, columns and so on... ;-)
function SQL_RESULT_FROM_ARRAY ($table, $columns, $idRow, $id, $F, $L) {
	// Is columns an array?
	if (!is_array($columns) {
		// No array
		trigger_error(sprintf("columns is not array. %s!=array", gettype($columns)));
	}

	// Prepare the SQL statement
	$SQL = "SELECT `".implode("`, `", $columns)."` FROM `{!_MYSQL_PREFIX!}_%s` WHERE ``='%s' LIMIT 1";

	// Return the result
	return SQL_QUERY_ESC($SQL,
		array(
			bigintval($id),
			$table,
			$idRow
		), $F, $L);
}

// ALTER TABLE wrapper function
function SQL_ALTER_TABLE ($sql, $F, $L) {
	// This is the default result...
	$result = false;

	// Determine index/fulltext/unique word
	$noIndex = ((eregi("INDEX", $sql) == false) && (eregi("FULLTEXT", $sql) == false) && (eregi("UNIQUE", $sql) == false);

	// Shall we add/drop?
	if (((eregi("ADD", $sql) > 0) || (eregi("DROP", $sql) > 0)) && ($noIndex)) {
		// Extract table name
		$tableArray = explode(" ", $sql);
		$tableName = str_replace("`", "", $tableArray[2]);

		// And column name as well
		$columnName = str_replace("`", "", $tableArray[4]);

		// Get column information
		$result = SQL_QUERY_ESC("SHOW COLUMNS FROM %s LIKE '%s'",
			array($tableName, $columnName), $F, $L);

		// Do we have no entry on ADD or an entry on DROP?
		if (((SQL_NUMROWS($result) == 0) && (eregi("ADD", $sql) > 0)) || ((SQL_NUMROWS($result) == 1) && (eregi("DROP", $sql) > 0))) {
			// Do the query
			$result = SQL_QUERY($sql, $F, $L, false);
		} // END - if
	} else {
		// Send it to the SQL_QUERY() function
		$result = SQL_QUERY($sql, $F, $L, false);
	}

	// Return result
	return $result;
}
//
?>
