<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 11/24/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : header.php                                       *
 * -------------------------------------------------------------------- *
 * Short description : Outputs header HTML code, will not when frameset *
 *           is active                                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Gibt nur dann HTML-Code fuer den Kopf-Bereich    *
 *           aus, wenn Frameset nicht aktiv ist                         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

global $header;

// Is the header already sent?
if (($header != "1") && ($header != "2")) {
	// If not in CSS mode generate the header
	if (($CSS != "1")) {
		// Generate header
		$TITLE = "";

		// Add title decorations? (left)
		if (!defined('__PAGE_TITLE')) {
			// Config and database connection valid?
			if ((isset($_CONFIG)) && (is_array($_CONFIG)) && (count($_CONFIG) > 1) && (is_resource($link)) && (isset($db))) {
				// Title decoration enabled?
				if ((getConfig('enable_title_deco') == "Y") && (getConfig('title_left') != "")) $TITLE .= trim(getConfig('title_left'))." ";

				// Do we have some extra title?
				if (!empty($EXTRA_TITLE)) {
					// Then prepent it
					$TITLE .= $EXTRA_TITLE." by ";
				} // END - if

				// Add main title
				$TITLE .= MAIN_TITLE;

				// Add title of module? (middle decoration will also be added!)
				if ((getConfig('enable_mod_title') == "Y") || ((empty($GLOBALS['what'])) && (empty($GLOBALS['action']))) || ($GLOBALS['module'] == "admin")) $TITLE .= " ".trim(getConfig('title_middle'))." ".ADD_MODULE_TITLE($GLOBALS['module']);

				// Add title from what file
				$MODE = "";
				if ($GLOBALS['module'] == "login") $MODE = "member";
				 elseif ($GLOBALS['module'] == "index") $MODE = "guest";
				if ((!empty($MODE)) && (getConfig('enable_what_title') == "Y")) $TITLE .= " ".trim(getConfig('title_middle'))." ".GET_MOD_DESCR($MODE, $GLOBALS['what']);

				// Add title decorations? (right)
				if ((getConfig('enable_title_deco') == "Y") && (getConfig('title_right') != "")) $TITLE .= " ".trim(getConfig('title_right'));

				// Remember title in constant for the template
				define('__PAGE_TITLE', html_entity_decode($TITLE));
			} elseif ((!isBooleanConstantAndTrue('mxchange_installed')) || (!isBooleanConstantAndTrue('admin_registered'))) {
				// Load language file because it was missing in installation finalizer step... *sigh*
				$FQFN = sprintf("inc/language/install_%s.php",
					GET_LANGUAGE()
				);
				LOAD_INC_ONCE($FQFN);

				// Installation mode
				define('__PAGE_TITLE', getMessage('INSTALLATION_OF_MXCHANGE'));
			} else {
				// Configuration not found!
				define('__PAGE_TITLE', getMessage('NO_CONFIG_FOUND_TITLE'));

				// Do not add the fatal message in installation mode
				if (basename($_SERVER['PHP_SELF']) != "install.php") addFatalMessage(getMessage('NO_CONFIG_FOUND'));
			}
		} // END - if

		// Save some little memory
		unset($TITLE);

		// Output page header code
		LOAD_TEMPLATE("page_header");

		// Include meta data in "guest" module
		if ($GLOBALS['module'] == "index") {
			// Load meta data template
			LOAD_TEMPLATE("metadata");

			// Add meta description to header
			if ((isBooleanConstantAndTrue('mxchange_installed')) && (isBooleanConstantAndTrue('admin_registered')) && (isset($db)) && (is_resource($link))) {
				// Add meta description not in admin and login module and when the script is installed
				META_DESCRIPTION($GLOBALS['module'], $GLOBALS['what']);
			} // END - if
		} // END - if

		// Include more header data here
		LOAD_TEMPLATE("header");

		// Include stylesheet
		LOAD_INC_ONCE("inc/stylesheet.php");
	} // END - if

	// Closing HEAD tag
	if ($CSS != "1") OUTPUT_HTML("</head>");
	$header = 1;
} // END - if

// Load body or not
if (($GLOBALS['module'] != "frametester") || (($GLOBALS['module'] == "frametester") && (isset($_GET['frame']))) || (($header == "1") && (!empty($_GET['frame']))) && ($CSS != "1")) {
	// Is the header sent and the script is not the mail confirmation script and not a CSS?
	if (($header == "1") && (basename($_SERVER['PHP_SELF']) != "mailid.php") && ($CSS != "1")) {
		// Add BODY tag
		LOAD_TEMPLATE("page_body");
		$header = 2;
	} // END - if
} // END - if

//
?>
