<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/13/2004 *
 * ===============                              Last change: 08/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : overview-inc.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Output standard task management                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Standart-Aufgaben-Management ausgeben            *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

function OUTPUT_STANDARD_OVERVIEW(&$result_tasks) {
	global $cacheArray, $_CONFIG;

	// First check for solved and not assigned tasks and assign them to current admin
	SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_task_system` SET assigned_admin='%s' WHERE assigned_admin < 1 AND status != 'NEW'",
		array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);

	// We currently don't want to install an extension so let's find out if we need...
	$EXT_LOAD_MODE = "register";
	$JOBS_DONE = true;

	// Open the extension directory
	$handle = opendir(PATH."inc/extensions/") or mxchange_die("Cannot read extension directory!");
	while ($file = readdir($handle)) {
		// Is this file an extension?
		if ((substr($file, 0, 4) == "ext-") && (substr($file, -4) == ".php")) {
			//* DEBUG: */ echo $file."<br />\n";
			// Possible newly installed extension found so we extract extension's name
			$ext_name = strtolower(substr($file, 4, -4)); // Keep always extension names on lower case!!!

			// Init variables
			$result = false;

			// Check if extension is installed or not
			$ext_ver = GET_EXT_VERSION($ext_name);

			// Is the extension not yet installed?
			if (empty($ext_ver)) {
				// Generate subject line
				$ext_subj = sprintf("[%s:]", $ext_name);

				// We maybe want to install an extension so let's test-drive it...
				if (LOAD_EXTENSION($ext_name, $EXT_LOAD_MODE)) {
					// Create a task for newly installed extension
					CREATE_NEW_EXTENSION_TASK(GET_CURRENT_ADMIN_ID(), $ext_subj, $ext_name);
				} // END - if
			} else {
				// Test-drive extension in update mode
				LOAD_INC(sprintf("inc/extensions/ext-%s.php", $ext_name));

				// Update extension if extension is installed and outdated
				//* DEBUG: */ print "ext={$ext_name},ver={$EXT_VERSION}/".GET_EXT_VERSION($ext_name)."<br />\n";
				if ($EXT_VERSION > $ext_ver) {
					// Update the extension
					EXTENSION_UPDATE($ext_name, $ext_ver);
				} // END - if

				if (isset($cacheArray['active_extensions'][$ext_name])) {
					// Maybe we want to keept the current extension active?
					if (($cacheArray['active_extensions'][$ext_name] == "Y") && (!EXT_IS_ACTIVE($ext_name))) {
						// Reactivate this extension!
						ACTIVATE_EXTENSION($ext_name);
					} // END - if
				} // END - if
			}
		} // END - if
	} // END - while

	// Close directory handle
	closedir($handle);

	// At last - but not least - check for own and new unassigned tasks...
	$result_tasks = SQL_QUERY_ESC("SELECT id, assigned_admin, userid, task_type, subject, text, task_created
FROM `{!_MYSQL_PREFIX!}_task_system`
WHERE assigned_admin='%s' OR (assigned_admin='0' AND status='NEW')
ORDER BY userid DESC, task_type DESC, subject, task_created DESC",
		array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);

	if (SQL_NUMROWS($result_tasks) > 0) {
		// New jobs found!
		$JOBS_DONE = false;
	} // END - if

	// Free the result
	SQL_FREERESULT($result);

	// Return status
	return $JOBS_DONE;
}

// Outputs selected tasks
function OUTPUT_SELECTED_TASKS ($POST, $result_tasks) {
	global $_CONFIG, $NOTES;
	if ((isset($POST['assign'])) && (count($POST['task']) > 0)) {
		// Assign / do tasks
		$OUT = ""; $SW = 2;
		foreach ($POST['task'] as $id => $sel) {
			$result_task = SQL_QUERY_ESC("SELECT id, userid, task_type, subject, text, task_created, status, assigned_admin FROM `{!_MYSQL_PREFIX!}_task_system` WHERE id=%s AND (assigned_admin='%s' OR (assigned_admin='0' AND status='NEW')) LIMIT 1",
				array(bigintval($id), GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
			if (SQL_NUMROWS($result_task) == 1) {
				// Task is valid...
				list($tid, $uid, $type, $subj, $text, $created, $status, $aid) = SQL_FETCHROW($result_task);
				SQL_FREERESULT($result_task);

				if ($aid == "0") {
					// Assgin current admin to unassgigned task
					SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_task_system` SET assigned_admin='%s' WHERE id=%s LIMIT 1",
						array(GET_CURRENT_ADMIN_ID(), bigintval($tid)), __FILE__, __LINE__);
				} // END - if

				$ADD = "";
				if ($type == "SUPPORT_MEMBER") {
					$mode = substr($text, 0, strpos($text, ":"));
					$text = substr($text, strpos($text, ":") + 1);
					$ADD = "<li>".ADMIN_TASK_SUPPORT_MODE.": <strong>".$mode."</strong></li>";
				} // END - if

				if ($uid > 0) {
					$result_user = SQL_QUERY_ESC("SELECT gender, surname, family, email FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
					 array(bigintval($uid)), __FILE__, __LINE__);
					if (SQL_NUMROWS($result_user) == 1) {
						list($gender, $sname, $fname, $email) = SQL_FETCHROW($result_user);
						SQL_FREERESULT($result_user);
						$ADD = "<li>".ADMIN_MEMBER_UID.": <strong>".ADMIN_USER_PROFILE_LINK($uid)." (<a href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".TRANSLATE_GENDER($gender)." ".$sname." ".$fname."</a>)</strong></li>";
					} // END - if
				} // END - if

				// Decode entities of the text
				$text = html_entity_decode($text);

				// Compile and insert text from task into table template
				$text = LOAD_TEMPLATE("admin_extensions_text", true, $text);

				// Initialize variables (no title for SQL commands by default)
				$ext_name = "";
				$title = TASK_NO_TITLE;

				// Shall I list SQL commands assigned to an extension installation or update task?
				if (((GET_EXT_VERSION("sql_patches") != '') && (getConfig('verbose_sql') == "Y")) || (!EXT_IS_ACTIVE("sql_patches"))) {
					$ext_name = substr($subj, 1, strpos($subj, ":") - 1);
					if ($type == "EXTENSION") {
						// Load SQL commands for registering
						$SQLs = EXTENSION_REGISTER($ext_name, $id, true);

						// Add notes to text
						$text .= $NOTES;

						// Set title
						$title = ADMIN_SQLS_EXECUTED_ON_REGISTER;
					} elseif ($type == "EXTENSION_UPDATE") {
						// Prepare extension name and version
						$ext_name = substr($ext_name, 7);
						$ext_name = substr($ext_name, 0, strpos($ext_name, "-"));
						$test = "[UPDATE-".$ext_name."-";
						$ext_ver = substr($subj, strlen($test));
						$ext_ver = substr($ext_ver, 0, strpos($ext_ver, ":"));

						// Load SQLs from file
						$SQLs = EXTENSION_UPDATE($ext_name, $ext_ver, true);

						// Add notes to text
						$text .= $NOTES;

						// Set title
						$title = ADMIN_SQLS_EXECUTED_ON_UPDATE;
					} else {
						// Remove extension's name
						$ext_name = "";
					}

					// Add SQLs to a table
					if (empty($SQLs)) $SQLs = array();
					if (empty($title)) $title = "";
					if ((!empty($ext_name)) && (GET_EXT_VERSION("sql_patches")) && (getConfig('verbose_sql') == "Y")) {
						// Add verbose SQL table
						$text .= EXTENSION_VERBOSE_TABLE($SQLs, $title, " class=\"admin_table top2 left2 right2\"", true, "100%")."<br />\n";
					} // END - if
				} else {
					// Run SQL commands in dry mode but only return the notes
					$SQLs = EXTENSION_UPDATE($ext_name, $ext_ver, true);
					$text .= $NOTES;
				}

				// Prepare array for the template
				$content = array(
					'sw'        => $SW,
					'subj'      => $subj,
					'add'       => $ADD,
					'text'      => $text,
					'created'   => MAKE_DATETIME($created, "1"),
					'extension' => $ext_name
				);

				// Load template
				$OUT .= LOAD_TEMPLATE("admin_overview_row", true, $content);

				// Which task do we actually have here?
				// @TODO Rewrite this to something with include files
				switch ($type)
				{
				case "EXTENSION": // Install new extensions
					$ext_name = substr($subj, 1, strpos($subj, ":") - 1);
					$result_lines = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_extensions` WHERE ext_name='%s' LIMIT 1",
					 array($ext_name), __FILE__, __LINE__);
					$lines = SQL_NUMROWS($result_lines);
					SQL_FREERESULT($result_lines);
					if ($lines == "0") {
						// New extension found
						$OUT .= LOAD_TEMPLATE("admin_ext_reg_form", true, array(
							'id'       => bigintval($id),
							'ext_name' => $ext_name
						));
					} else {
						// Task is closed so nothing is todo
						$OUT .= "<div class=\"admin_failed\">".ADMIN_EXT_ALREADY_REGISTERED."</div>\n";

						// Close task but not already closes or deleted or update tasks
						if (($status != "CLOSED") && ($status != "DELETED") && ($type != "EXTENSION_UPDATE")) {
							// Solve the task
							RUN_FILTER('solve_task', $tid);
						} // END - if
					}
					break;

				case "EXTENSION_UPDATE": // Extension update
					// Extension updates are installed automatically
					$OUT .= "<div class=\"admin_failed medium\">".ADMIN_EXTENSION_UPDATED."</div>\n";

					// Close task
					if (($status != "CLOSED") && ($status != "DELETED")) {
						// Solve the task
						RUN_FILTER('solve_task', $tid);
					} // END - if
					break;

				case "SUPPORT_MEMBER": // Assign on member's support request
					switch ($mode)
					{
					default: // @TODO Unknown support mode
						DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown support mode %s detected. This part is under construction!", $mode));
						$OUT .= "<div class=\"admin_failed medium\">".ADMIN_UNKNOWN_SUPPORT_MODE_1.$mode.ADMIN_UNKNOWN_SUPPORT_MODE_2."</div>\n";
						break;
					}
					break;

				case "PAYOUT_REQUEST": // Payout requests
					if (EXT_IS_ACTIVE("payout")) {
						// Extension is installed so let him send a notification to the user
						$result_pay = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_user_payouts` WHERE userid=%s AND payout_timestamp=%s LIMIT 1",
							array(bigintval($uid), bigintval($created)), __FILE__, __LINE__);
						list($pid) = SQL_FETCHROW($result_pay);
						SQL_FREERESULT($result_pay);

						if ((!empty($pid)) && ($pid > 0)) {
							// Payout ID can be obtained
							$content = array(
								'pid' => $pid,
								'tid' => $tid,
							);
							$OUT .= LOAD_TEMPLATE("admin_payout_overview_form", true, $content);
						} else {
							// Problem obtaining payout ID
							$OUT .= "<div class=\"admin_failed medium\">".PAYOUT_OBTAIN_ID_FAILED."</div>\n";
						}
					} else {
						// Extension is not installed
						$OUT .= "<div class=\"admin_failed medium\">".ADMIN_PAYOUT_NOT_INSTALLED."</div>\n";
					}
					break;

				case "WERNIS_REQUEST": // Wernis requests
					if (EXT_IS_ACTIVE("wernis")) {
						// Extension is installed so let him send a notification to the user
						$result_pay = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_user_wernis` WHERE userid=%s AND wernis_timestamp=%s LIMIT 1",
							array(bigintval($uid), bigintval($created)), __FILE__, __LINE__);
						list($pid) = SQL_FETCHROW($result_pay);
						SQL_FREERESULT($result_pay);

						if ((!empty($pid)) && ($pid > 0)) {
							// Payout ID can be obtained
							$content = array(
								'pid' => $pid,
								'tid' => $tid,
							);
							$OUT .= LOAD_TEMPLATE("admin_wernis_overview_form", true, $content);
						} else {
							// Problem obtaining wernis ID
							$OUT .= "<div class=\"admin_failed medium\">".WERNIS_OBTAIN_ID_FAILED."</div>\n";
						}
					} else {
						// Extension is not installed
						$OUT .= "<div class=\"admin_failed medium\">".ADMIN_WERNIS_NOT_INSTALLED."</div>\n";
					}
					break;

				case "HOLIDAY_REQUEST": // Holiday requests
					$OUT .= LOAD_TEMPLATE("admin_task_holiday", true, $uid);
					break;

				case "NL_UNSUBSCRIBE": // Newsletter unsubscriptions
					$result = SQL_QUERY_ESC("SELECT nl_timespan FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
						array(bigintval($uid)), __FILE__, __LINE__);
					list($span) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);

					if ($span > 0) {
						// Undone unscubscribe request
						$content = array(
							'uid' => $uid,
							'id'  => $tid
						);
						$OUT .= LOAD_TEMPLATE("admin_newsletter_tsk", true, $content);
					} else {
						// Already unsubscribed
						$OUT .= "<div class=\"admin_failed medium\">".ADMIN_NL_UNSUBSCRIBE_ALREADY."</div>\n";
					}
					break;

				default: // Unknown task type
					DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown task type %s detected.", $type));
					$OUT .= "<div class=\"admin_failed medium\">".ADMIN_UNKNOWN_TASK_TYPE_1.$type.ADMIN_UNKNOWN_TASK_TYPE_2.$id.ADMIN_UNKNOWN_TASK_TYPE_3."</div>\n";
					break;
				}
				$OUT .= "  </td>
  <td width=\"1%\" class=\"switch_sw".$SW." bottom2 right2\">&nbsp;</td>
</tr>\n";
			} // END - if
			$SW = 3 - $SW;
		} // END - foreach
		define('__TASK_ROWS', $OUT);

		// Load final template
		LOAD_TEMPLATE("admin_overview_list");
	} else {
		if ((isset($POST['task'])) && ((sizeof($POST['task']) > 0) || ($POST['task'][0] == "1"))) {
			// Only unassign / delete tasks when there are selected tasks posted
			if (!empty($POST['unassign'])) {
				// Unassign from tasks
				foreach ($POST['task'] as $id => $sel) {
					SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_task_system` SET assigned_admin=0 WHERE id=%s AND assigned_admin=%s LIMIT 1",
						array(bigintval($id), GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
				}
			} elseif (isset($POST['del'])) {
				// Delete tasks
				foreach ($POST['task'] as $id => $sel) {
					SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_task_system` WHERE id=%s AND assigned_admin IN (%s,0) LIMIT 1",
						array(bigintval($id), GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
				}
			}

			// Update query
			$result_tasks = SQL_QUERY_ESC("SELECT id, assigned_admin, userid, task_type, subject, text, task_created FROM `{!_MYSQL_PREFIX!}_task_system` WHERE assigned_admin=%s OR (assigned_admin=0 AND status='NEW') ORDER BY task_created DESC",
			 array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
		} // END - if

		// There are uncompleted jobs!
		LOAD_TEMPLATE("admin_overview_header");
		$SW = 2;
		while (list($id, $admin, $uid, $type, $subj, $text, $created) = SQL_FETCHROW($result_tasks)) {
			$infos = "---";
			if ($admin == "0") {
				// No admin currently is assigned
				$admin = "<div class=\"admin_note\">".ADMIN_NO_ADMIN_ASSIGNED."</div>";
			} else {
				// Load admin's data
				$login = GET_ADMIN_LOGIN($admin);
				if ($login != "***") {
					// Admin found
					$admin = "<a href=\"{!URL!}/modules.php?module=admin&amp;what=admins_contct&amp;admin=".$admin."\">".$login."</a>";
				} else {
					// Maybe deleted?
					$admin = "<div class=\"admin_note\">".ADMIN_ID_404_1.$admin.ADMIN_ID_404_2."</div>";
				}
			}

			// Get task type
			$type_out = constant('ADMIN_TASK_IS_'.strtoupper($type).'');

			$type2 = substr($text, 0, strpos($text, ":"));
			// Generate infos
			switch ($type)
			{
			case "EXTENSION":
			case "EXTENSION_UPDATE":
				$infos = substr($subj, 1, strpos($subj, ":") - 1);
				break;
			}

			if ($uid > 0) {
				// Member found otherwise it's a system task
				$uid = ADMIN_USER_PROFILE_LINK($uid);
			} else {
				$uid = "<em>".ADMIN_IS_SYSTEM_TASK."</em>";
			}

			// Prepare content
			$content = array(
				'sw'      => $SW,
				'id'      => $id,
				'admin'   => $admin,
				'infos'   => $infos,
				'uid'     => $uid,
				'type'    => $type_out,
				'created' => MAKE_DATETIME($created, "2")
			);

			// Do we have extension task?
			if (($type == "EXTENSION") && (GET_EXT_VERSION($infos) == "")) {
				// Load extension row template
				LOAD_TEMPLATE("admin_overview_list_ext_rows", false, $content);
			} else {
				// Load default row template
				LOAD_TEMPLATE("admin_overview_list_rows", false, $content);
			}

			// Switch color
			$SW = 3 - $SW;
		}
		// Free memory
		SQL_FREERESULT($result_tasks);

		// Load footer template
		LOAD_TEMPLATE("admin_overview_footer");
	}
}
//
?>
