<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/26/2004 *
 * ================                             Last change: 06/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_autopurge.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Find inactive accounts and just list them        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Inaktive Accounts finden und dann auflisten      *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Exclude default referal id if set
$EXCLUDE_LIST = "";
if (getConfig('def_refid') > 0) {
	$EXCLUDE_LIST = " AND d.userid != ".getConfig('def_refid')."";
} // END - if

// Check for more extensions
if (EXT_IS_ACTIVE("beg"))                  $EXCLUDE_LIST .= " AND d.userid != ".getConfig('beg_uid')."";
if (EXT_IS_ACTIVE("bonus"))                $EXCLUDE_LIST .= " AND d.userid != ".getConfig('bonus_uid')."";
if (EXT_IS_ACTIVE("doubler"))              $EXCLUDE_LIST .= " AND d.userid != ".getConfig('doubler_uid')."";
if (GET_EXT_VERSION("holiday") >= "0.1.3") $EXCLUDE_LIST .= " AND d.holiday_active='N'";

// Check for all accounts
$result = SQL_QUERY_ESC("SELECT DISTINCT d.userid, d.gender, d.surname, d.family, d.email, d.joined, d.last_online, d.ap_notified
FROM `{!_MYSQL_PREFIX!}_user_data` AS d
WHERE d.status='CONFIRMED' AND d.joined < (UNIX_TIMESTAMP() - %s) AND d.last_online < (UNIX_TIMESTAMP() - %s) AND d.ap_notified < (UNIX_TIMESTAMP() - %s)
".$EXCLUDE_LIST."
ORDER BY d.userid", array(getConfig('ap_inactive_since'), getConfig('ap_inactive_since'), getConfig('ap_inactive_since')), __FILE__, __LINE__);

if (SQL_NUMROWS($result) > 0)
{
	// Ok, we have found some inactive accounts
	$SW = 2; $OUT = "";
	while (list($uid, $gender, $sname, $fname, $email, $joined, $last, $notified) = SQL_FETCHROW($result))
	{
		// Prepare data for the row template
		$content = array(
			'sw'       => $SW,
			'uid'      => ADMIN_USER_PROFILE_LINK($uid),
			'gender'   => TRANSLATE_GENDER($gender),
			'sname'    => $sname,
			'fname'    => $fname,
			'email'    => "<a href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".$email."</a>",
			'joined'   => MAKE_DATETIME($joined, "2"),
			'last'     => MAKE_DATETIME($last, "2"),
			'notified' => MAKE_DATETIME($notified, "2"),
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("admin_list_autopurge_row", true, $content);
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);
	define('__AUTOPURGE_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_list_autopurge");
}
 else
{
	// All members are active or you don't have any registered
	LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_AUTOPURGE_ALL_ACTIVE'));
}
//
?>
