<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/15/2003 *
 * ===============                              Last change: 04/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-logs.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Management for access log files                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Management fuer Zugriffslogbuecher               *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (!empty($_GET['access'])) {
	// Secure input and construct FQFN
	$access = SQL_ESCAPE(strip_tags($_GET['access']));
	$target = sprintf("%slogs/%s", constant('PATH'), $access);

	// Is the file valid and readable?
	if (FILE_READABLE($target)) {
		// Load it directly
		$content = READ_FILE($target);

		// Save old content
		$OUTPUT = ob_get_contents();

		// Clean content
		clearOutputBuffer();

		// Set header
		if (substr($access, -3, 3) == "log") {
			// Output header
			header("Content-Type: text/plain");
		} elseif (substr($access, -3, 3) == ".gz") {
			// @TODO Fix content-type here
			header("Content-Type: text/plain");
		} elseif (substr($access, -3, 3) == ".bz2") {
			// @TODO Fix content-type here
			header("Content-Type: text/plain");
		} else {
			// Restore old content
			OUTPUT_HTML($OUTPUT);

			// Output message
			LOAD_TEMPLATE("admin_settings_saved", false, UNKNOWN_LOGFILE_FORMAT_1.$access.UNKNOWN_LOGFILE_FORMAT_2);
			return;
		}

		// Output the logfile's content and exit
		print($content);
		exit;
	} else {
		// Not readable!
		LOAD_TEMPLATE("admin_settings_saved", false, LOGFILE_NOT_READABLE_1.$access.LOGFILE_NOT_READABLE_2);
	}
} else {
	// List access logfiles
	$dir = PATH.getConfig('logs_base')."/";
	if (is_dir($dir)) {
		// logs directory does exist
		OUTPUT_HTML("<ol>");
		$handle = opendir($dir) or mxchange_die("Cannot open directory ".getConfig('logs_base')."!");
		while ($file = readdir($handle)) {
			// We currenly only like files with "access" as prefix, should be more flexible!
			if (substr($file, 0, 6) == "access") {
				// Okay, let us print it out
				OUTPUT_HTML("<li><a href=\"{!URL!}/modules.php?module=admin&amp;what=".$GLOBALS['what']."&access=".urlencode($file)."\">".$file."</a></li>");
			}
		}
		closedir($handle);
		OUTPUT_HTML("</ol>");
	} else {
		// logs directory does not exist
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_LOGS_DIR_404_1.getConfig('logs_base').ADMIN_LOGS_DIR_404_2);
	}
}

//
?>
