<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/19/2003 *
 * ===============                              Last change: 12/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-payments.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Payments (points) for confirmed mails            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Verguetungen fuer bestaetigte Mails              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (empty($_GET['do'])) unset($_GET['do']);

if (((empty($_POST['t_wait'])) || (empty($_POST['payment']))) && (!empty($_GET['do'])) && ($_GET['do'] == "add")) {
	unset($_POST['ok']);
}

if (isset($_POST['ok'])) {
	$SQL = array();
	switch ($_GET['do']) {
	case "add":
		$SQLs[] = "INSERT INTO `{!_MYSQL_PREFIX!}_payments` (time, payment, mail_title, price) VALUES ('".$_POST['t_wait']."','".$_POST['payment']."','".$_POST['title']."','".$_POST['price']."')";
		$result = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_payments` WHERE time='%s' LIMIT 1",
		 array($_POST['t_wait']), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Free memory
			$SQLs[0] = "";
			SQL_FREERESULT($result);
		}
		break;

	case "edit":
		foreach ($_POST['time'] as $id => $value) {
			$SQLs[] = "UPDATE `{!_MYSQL_PREFIX!}_payments` SET time='".$value."', payment='".$_POST['pay'][$id]."', price='".$_POST['price'][$id]."', mail_title='".$_POST['title'][$id]."' WHERE id='".$id."' LIMIT 1";
		}
		break;

	case "del":
		foreach ($_POST['id'] as $id => $value) {
			$SQLs[] = "DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_payments` WHERE id='".$id."' LIMIT 1";
		}
		break;
	}

	// Save settings
	if (count($SQLs) > 0) {
		// Run all queries
		RUN_FILTER('run_sqls', array('dry_run' => false, 'sqls' => $SQLs));
		$content = "<span class=\"admin_failed\">".SETTINGS_SAVED."</span>";
	} else {
		// Nothing has changed!
		$content = "<span class=\"admin_failed\">".SETTINGS_NOT_SAVED."</span>";
	}

	// Output template
	LOAD_TEMPLATE("admin_settings_saved", false, $content);
} elseif ((isset($_POST['del'])) && (SELECTION_COUNT($_POST['sel']) > 0)) {
	// Delete entries here
	$SW = 2; $OUT = "";
	foreach ($_POST['sel'] as $id => $value) {
		$result = SQL_QUERY_ESC("SELECT time, mail_title FROM `{!_MYSQL_PREFIX!}_payments` WHERE id=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		list($time, $title) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare array for the row template
		$content = array(
			'sw'    => $SW,
			'id'    => $id,
			'time'  => $time,
			'title' => $title,
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE("admin_del_payments_row", true, $content);
		$SW = 3 - $SW;
	}
	define('__PAYMENT_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_del_payments");
} elseif ((isset($_POST['edit'])) && (SELECTION_COUNT($_POST['sel']) > 0)) {
	// Edit entries
	$SW = 2; $OUT = "";
	foreach ($_POST['sel'] as $id => $value) {
		$result = SQL_QUERY_ESC("SELECT time, payment, mail_title, price FROM `{!_MYSQL_PREFIX!}_payments` WHERE id=%s LIMIT 1",
		 array(bigintval($id)), __FILE__, __LINE__);
		list($time, $pay, $title, $price) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare array for the row template
		$content = array(
			'sw'    => $SW,
			'id'    => $id,
			'time'  => $time,
			'title' => $title,
			'pay'   => $pay,
			'price' => $price,
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE("admin_edit_payments_row", true, $content);
		$SW = 3 - $SW;
	}
	define('__PAYMENT_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_edit_payments");
} else {
	// Referal levels
	$result = SQL_QUERY("SELECT id, time, payment, mail_title, price FROM `{!_MYSQL_PREFIX!}_payments` ORDER BY time", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Make referal levels editable and deletable
		$SW = 2; $OUT = "";

		// List already existing categories for editing
		while (list($id, $time, $pay, $title, $price) = SQL_FETCHROW($result)) {
			$pay   = TRANSLATE_COMMA($pay);
			$price = TRANSLATE_COMMA($price);

			// Prepare array for the row template
			$content = array(
				'sw'    => $SW,
				'id'    => $id,
				'time'  => $time,
				'title' => $title,
				'pay'   => $pay,
				'price' => $price,
			);

			// Load row template and switch colors
			$OUT .= LOAD_TEMPLATE("admin_payments_list_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__PAYMENT_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_list_payments");
	}

	// Form for adding new referal levels
	LOAD_TEMPLATE("admin_add_payment");
}

//
?>
